/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
/*******************************************************************************
 * Source date: 9 Apr 1997 21:45:13 GMT
 * netscape/fonts/cstrm module C stub file
 * Generated by jmc version 1.8 -- DO NOT EDIT
 ******************************************************************************/

#include <stdlib.h>
#include <string.h>
#include "xp_mem.h"

/* Include the implementation-specific header: */
#include "Pcstrm.h"

/* Include other interface headers: */

/*******************************************************************************
 * cstrm Methods
 ******************************************************************************/

#ifndef OVERRIDE_cstrm_getInterface
JMC_PUBLIC_API(void*)
_cstrm_getInterface(struct cstrm* self, jint op, const JMCInterfaceID* iid, JMCException* *exc)
{
	if (memcmp(iid, &cstrm_ID, sizeof(JMCInterfaceID)) == 0)
		return cstrmImpl2cstrm(cstrm2cstrmImpl(self));
	return _cstrm_getBackwardCompatibleInterface(self, iid, exc);
}
#endif

#ifndef OVERRIDE_cstrm_addRef
JMC_PUBLIC_API(void)
_cstrm_addRef(struct cstrm* self, jint op, JMCException* *exc)
{
	cstrmImplHeader* impl = (cstrmImplHeader*)cstrm2cstrmImpl(self);
	impl->refcount++;
}
#endif

#ifndef OVERRIDE_cstrm_release
JMC_PUBLIC_API(void)
_cstrm_release(struct cstrm* self, jint op, JMCException* *exc)
{
	cstrmImplHeader* impl = (cstrmImplHeader*)cstrm2cstrmImpl(self);
	if (--impl->refcount == 0) {
		cstrm_finalize(self, exc);
	}
}
#endif

#ifndef OVERRIDE_cstrm_hashCode
JMC_PUBLIC_API(jint)
_cstrm_hashCode(struct cstrm* self, jint op, JMCException* *exc)
{
	return (jint)self;
}
#endif

#ifndef OVERRIDE_cstrm_equals
JMC_PUBLIC_API(jbool)
_cstrm_equals(struct cstrm* self, jint op, void* obj, JMCException* *exc)
{
	return self == obj;
}
#endif

#ifndef OVERRIDE_cstrm_clone
JMC_PUBLIC_API(void*)
_cstrm_clone(struct cstrm* self, jint op, JMCException* *exc)
{
	cstrmImpl* impl = cstrm2cstrmImpl(self);
	cstrmImpl* newImpl = (cstrmImpl*)malloc(sizeof(cstrmImpl));
	if (newImpl == NULL) return NULL;
	memcpy(newImpl, impl, sizeof(cstrmImpl));
	((cstrmImplHeader*)newImpl)->refcount = 1;
	return newImpl;
}
#endif

#ifndef OVERRIDE_cstrm_toString
JMC_PUBLIC_API(const char*)
_cstrm_toString(struct cstrm* self, jint op, JMCException* *exc)
{
	return NULL;
}
#endif

#ifndef OVERRIDE_cstrm_finalize
JMC_PUBLIC_API(void)
_cstrm_finalize(struct cstrm* self, jint op, JMCException* *exc)
{
	/* Override this method and add your own finalization here. */
	XP_FREEIF(self);
}
#endif

/*******************************************************************************
 * Jump Tables
 ******************************************************************************/

const struct cstrmInterface cstrmVtable = {
	_cstrm_getInterface,
	_cstrm_addRef,
	_cstrm_release,
	_cstrm_hashCode,
	_cstrm_equals,
	_cstrm_clone,
	_cstrm_toString,
	_cstrm_finalize,
	_cstrm_IsWriteReady,
	_cstrm_Write,
	_cstrm_Abort,
	_cstrm_Complete
};

/*******************************************************************************
 * Factory Operations
 ******************************************************************************/

JMC_PUBLIC_API(cstrm*)
cstrmFactory_Create(JMCException* *exception, struct nfrc* a, const char* b, const char* c)
{
	cstrmImplHeader* impl = (cstrmImplHeader*)XP_NEW_ZAP(cstrmImpl);
	cstrm* self;
	if (impl == NULL) {
		JMC_EXCEPTION(exception, JMCEXCEPTION_OUT_OF_MEMORY);
		return NULL;
	}
	self = cstrmImpl2cstrm(impl);
	impl->vtablecstrm = &cstrmVtable;
	impl->refcount = 1;
	_cstrm_init(self, exception, a, b, c);
	if (JMC_EXCEPTION_RETURNED(exception)) {
		XP_FREE(impl);
		return NULL;
	}
	return self;
}

